// stdafx.cpp : source file that includes just the standard includes
//	SaxAnalyzer.pch will be the pre-compiled header
//	stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"

#ifdef _DEBUG
BOOL g_bDebugMode=TRUE;
#else
BOOL g_bDebugMode=FALSE;
#endif
BOOL g_nTraceLevel=TRC_INFO; // TRC_ERROR

FILE *g_logFile=NULL;

void trace(int nLevel, char*szOutput)
{
	if (!g_bDebugMode || strlen(szOutput)==0 || g_nTraceLevel<nLevel)
		return;

	// first of all, turn all characters to visible chars
	//
	char szTemp[4096];
	if (strlen(szOutput)>4096)
	{
		strncpy(szTemp, szOutput, 4096);
		szTemp[4095]='\0';
	}
	else
		strcpy(szTemp,szOutput);

	unsigned int len = strlen(szTemp);
	for (unsigned int i=0;i<len;i++)
		if (szTemp[i]<32 && szTemp[i]!=0x0D && szTemp[i]!=0x0A) szTemp[i]=32;
	//strcat(szTemp,"\r\n");

	// then open a file and output the data
	if (!g_logFile)
		g_logFile=fopen("logfile.log","w+"); // create it if does not exist yet

	if (g_logFile)
	{
		fputs(szTemp,g_logFile);
		fflush(g_logFile);
	}
	
	// finally output to debug console window
#ifdef _DEBUG
 #ifdef _AFXDLL // MFC output
	afxDump << szTemp;
 #else // no MFC output, just output to the debug console
	::OutputDebugString(szTemp);
 #endif


#endif


}


void trace2(int nLevel, char*szOutput1, char *szOutput2)
{
	char szTemp[4096];
	if (!szOutput1 || !szOutput2 || strlen(szOutput1)>4096)
		return;
	
	// concatenate both strings and trace the result in the usual way

	strcpy(szTemp, szOutput1);

	long n = strlen(szOutput2);
	if ( (strlen(szTemp)+n)>4096 ) 
	{
		strncat(szTemp, szOutput2, 4096-strlen(szTemp));
		szTemp[4095]='\0';
	}
	else
		strcat(szTemp, szOutput2);

	trace(nLevel, szTemp);
}


void traceendl()
{
#ifdef _DEBUG
#ifdef _AFXDLL
	afxDump << "\r\n";
#endif
#endif
}

void traceshutdown()
{
	if (g_logFile)
	{
		fclose(g_logFile);
		g_logFile = NULL;
	}
}