
#ifndef _HTMLPARSER_
#define _HTMLPARSER_


#ifndef UINT
 #define UINT unsigned int
#endif

class HTMLParser
{
public:
	// post-processings
	virtual void UpdateTagsAttributes(char *szHtml, char *szBaseUrl);

	virtual bool GetNextTag(char *szString, UINT nBeginString, UINT &nBeginIndex, UINT &nEndIndex, UINT &nNbMultipleSpaces);
	virtual bool GetNextAttribute(char *szString,UINT nBeginString,
								 UINT nBeginIndex,UINT nEndIndex,
								 UINT &nBeginAttrName , UINT &nEndAttrName, 
								 UINT &nBeginAttrValue, UINT &nEndAttrValue,
								 UINT &nNbMultipleSpaces);

	// Helpers
public:
	virtual void AddQuotes(char *szString);
	virtual void RemoveQuotes(char *szString);
	virtual void SplitBaseUrl(char *szNewsPage, char *szHostname,char *szCurrentDirectory,bool bNeedTrailingSlash);
};



#endif // -HTMLPARSER