
#ifndef _XMLREFRESH_INTERFACE
#define _XMLREFRESH_INTERFACE


#include <objbase.h>

#include "XmlIdDef.h"
#include "Templates.h"
#include "Element.h"
#include "..\xmlparser\xmlparse.h"


// Forward references for GUIDs
extern const IID IID_IXmlStats ;


 


////////////////////////////////////////////////////////////////////////////////////////
//
//
// IXmlStats interface
//
//
/////////////////////////////////////////////////////////////////////////////////////////
// Stephane Rodriguez, 1st july 2002
//
//

#define APICALL

interface IXmlStats : IUnknown
{
	// Accessors
	//
	virtual CElement*			__stdcall getRootElement() = 0 ;
	virtual XML_Parser&			__stdcall getParser() = 0 ;

	// Methods
	//

	// parse the XML file
	virtual BOOL __stdcall process(char *szFilename) = 0 ;
	virtual void __stdcall forceStop() = 0 ; // command to stop processing inside ::process

	// generate a debug log of the internal structure
	virtual void __stdcall dump() = 0 ;

	// drop the internal structure
	virtual void __stdcall clean() = 0 ;

} ;




#endif

//
